#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void print_matrix(char **Matrix, int size);

main(int argc, char *argv[])
{
   FILE *Datafile;
   char *Datafile_name[80];
   int   Num_entries;
   int   M;
   int   M_2;
   int   Index;
   int   i = 0;
   int   j = 0;
   int   k = 0;
   int   l = 0;
   int   x = 0;
   int   y = 0;
   char **Matrix;
   char  *Pointer;
   char  *Buffer;

   if (argc > 1)
      strcpy(Datafile_name, argv[1]);
   else
      strcpy(Datafile_name, "test.dat");

   if ((Datafile = fopen(Datafile_name, "r")) == NULL)
   {
      perror("Opering data file");
      exit(1);
   }
   
   fscanf(Datafile, "%d  %d%*c", &Num_entries, &M);

#ifdef DEBUG_main
   printf("Num_entries = %d, M = %d\n", Num_entries, M);
#endif

   M_2 = 2 * M;
   
   if ((Buffer = (char *) malloc(sizeof(char) * M_2)) == NULL)
   {
      perror("Allocating Buffer's memory");
      exit(1);
   }
   
   if ((Matrix = (char **) malloc(sizeof(char *) * M_2)) == NULL)
   {
      perror("Allocating Matrix's pointer");
      exit(1);
   }
   
   if ((Pointer = (char *) malloc(sizeof(char) * M_2 * M_2)) == NULL)
   {
      perror("Allocating Matrix's memory");
      exit(1);
   }

   for (k = 0, Index = 0; k < M_2; k++, Index += M_2)
   {
      Matrix[k] = &(Pointer[Index]);
      for (l = 0; l < M_2; l++)
         Matrix[k][l] = ' ';
   }

   for (k = 0; k <= Num_entries; k++)
   {
      fscanf(Datafile, "%d, %d%*c", &i, &j);

#define METHOD_0
#ifdef METHOD_0
      Matrix[i][j] = '#';
#endif

#ifdef METHOD_1
      Matrix[i][j] = '#';
      Matrix[i + M][j] = '#';
      Matrix[i][j + M] = '#';
      Matrix[i + M][j + M] = '#';
#endif
#ifdef METHOD_2
      x = i * 2;
      y = j * 2;
#ifdef DEBUG_main
      printf("x = %d, y = %d\n", x, y);
#endif
      Matrix[x][y] = '#';
      Matrix[x + 1][y] = '#';
      Matrix[x][y + 1] = '#';
      Matrix[x + 1][y + 1] = '#';
#endif
#ifdef DEBUG_main
      printf("(%d, %d)\n", i, j);
#endif
   }

   fclose(Datafile);
#ifdef METHOD_0
   print_matrix(Matrix, M);
#endif
#ifdef METHOD_1
   print_matrix(Matrix, M);
   print_matrix(Matrix, M_2);
#endif
#ifdef METHOD_2
   print_matrix(Matrix, M);
   print_matrix(Matrix, M_2);
#endif

}

void print_matrix(char **Matrix, int Size)
{
   int i;
   int j;
   
   printf("\\begin{tabular}{");
   for (j = 0; j < Size; j++)
      printf("|c");
   printf("|c|} \\hline\n");

   printf("  ");

   for (j = 0; j < Size; j++)
      printf("& %2d", j);
   printf("\\\\ \\hline\n");
   
   for (i = 0; i < Size; i++)
   {
      printf("%2d", i);
      for (j = 0; j < Size; j++)
         if (Matrix[i][j] == '#')
            printf("&  $\\oplus$");
         else
            printf("&  ");

      printf("\\\\ \\hline\n");  
   }
   printf("\\end{tabular}\n");
}
